Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QNucleus.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QNucleus.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QNucleus.cc	(revision 1055)
@@ -2837,49 +2842,49 @@
     //static G4int mesonPDG[45]  =  {221,111,211,-211,311,321,-311,-321,331,       //  0- 8
     // Vector resonances   (1):    omega,Rh0,Rh+,Rho-,K0*,K+*,AK0*,AK-*,Phi
-		  //																							 						223,113,213,-213,313,323,-313,-323,333,        //  9-18
+    //                              223,113,213,-213,313,323,-313,-323,333,        //  9-18
     // Tensor D-resonances (2):     f2 ,a20,a2+, a2-,K20,K2+,AK20,AK2-,f2'
-		  //																						 							225,115,215,-215,315,325,-315,-325,335,        // 19-27
+    //                              225,115,215,-215,315,325,-315,-325,335,        // 19-27
     // Tensor F-resonances (3):     om3,ro3,r3+,rh3-,K30,K3+,AK30,AK3-,Phi3
     //                              227,117,217,-217,317,327,-317,-327,337,        // 28-35
     // Tensor G-resonances (4):     f4 ,a40,a4+, a4-,K40,K4+,AK40,AK4-,f4'
-		  //						                        229,119,219,-219,319,329,-319,-329,339};       // 36-44
+    //                              229,119,219,-219,319,329,-319,-329,339};       // 36-44
     // Baryon octet       (1/2):    n  , an  , p  , ap  ,lamb,alamb, sig-,asig-
     //static G4int baryonPDG[72]={2112,-2112,2212,-2212,3122,-3122,3112,-3112,     // 45-52
-		  // Hyperon octet     (1/2): sig0,asig0,sig+,asig+,ksi-,aksi-,ksi0,aksi0
-		  //																												3212,-3212,3222,-3222,3312,-3312,3322,-3322,     // 53-60
+    // Hyperon octet     (1/2): sig0,asig0,sig+,asig+,ksi-,aksi-,ksi0,aksi0
+    //                            3212,-3212,3222,-3222,3312,-3312,3322,-3322,     // 53-60
     // Baryon decuplet   (3/2): del-,adel-,del0,adel0,del+,adel+,dl++,adl++,sis-,asis-
-		  //																										1114,-1114,2114,-2114,2214,-2214,2224,-2224,3114,-3114,//70
-		  //                          sis0,asis0,sis+,asis+,kss-,akss-,kss0,akss0,omeg,aomeg
-		  //																										3214,-3214,3224,-3224,3314,-3314,3324,-3324,3334,-3334,//80
+    //                          1114,-1114,2114,-2114,2214,-2214,2224,-2224,3114,-3114,//70
+    //                          sis0,asis0,sis+,asis+,kss-,akss-,kss0,akss0,omeg,aomeg
+    //                          3214,-3214,3224,-3224,3314,-3314,3324,-3324,3334,-3334,//80
     // Baryon octet      (5/2): n5/2,an5/2,p5/2,ap5/2,l5/2,al5/2,si5-,asi5-
-		  //																										2116,-2116,2216,-2216,3126,-3126,3116,-3116,       // 81-88
-		  //                          si50,asi50,si5+,asi5+,ks5-,aks5-,ks50,aks50
+    //                          2116,-2116,2216,-2216,3126,-3126,3116,-3116,       // 81-88
+    //                          si50,asi50,si5+,asi5+,ks5-,aks5-,ks50,aks50
     //                          3216,-3216,3226,-3226,3316,-3316,3326,-3326,       // 89-96
     // Baryon decuplet  (7/2): dl5-,adl5-,dl50,adl50,dl5+,adl5+,d5++,ad5++,si5-,asi5-
-				//																								1118,-1118,2118,-2118,2218,-2218,2228,-2228,3118,-3118, //106
-		  //                        si50,asi50,si5+,asi5+,ks5-,aks5-,ks50,aks50,ome5,aome5
-				//																						  3218,-3218,3228,-3228,3318,-3318,3328,-3328,3338,-3338};//116
+    //                        1118,-1118,2118,-2118,2218,-2218,2228,-2228,3118,-3118, //106
+    //                        si50,asi50,si5+,asi5+,ks5-,aks5-,ks50,aks50,ome5,aome5
+    //                        3218,-3218,3228,-3228,3318,-3318,3328,-3328,3338,-3338};//116
     // One should take into account, that #of mesons & baryons can be cut in G4Quas::HadrQE
-				//G4int nP= theWorld->GetQPEntries(); // A#of initialized particles in CHIPS World
-				////@@ Make special parametyer to cut high resonances for nuclear fragmentation !!
-				//G4int          nMesons  = 45;
-				//if     (nP<34) nMesons  =  9;
-				//else if(nP<51) nMesons  = 18;
-				//else if(nP<65) nMesons  = 27;
-				//else if(nP<82) nMesons  = 36;
-				//G4int          nBaryons = 72;
-				//if     (nP<45) nBaryons = 16;
-				//else if(nP<59) nBaryons = 36;
-				//else if(nP<76) nBaryons = 52;
+    //G4int nP= theWorld->GetQPEntries(); // A#of initialized particles in CHIPS World
+    ////@@ Make special parametyer to cut high resonances for nuclear fragmentation !!
+    //G4int          nMesons  = 45;
+    //if     (nP<34) nMesons  =  9;
+    //else if(nP<51) nMesons  = 18;
+    //else if(nP<65) nMesons  = 27;
+    //else if(nP<82) nMesons  = 36;
+    //G4int          nBaryons = 72;
+    //if     (nP<45) nBaryons = 16;
+    //else if(nP<59) nBaryons = 36;
+    //else if(nP<76) nBaryons = 52;
     // **********************************************************************************
     //G4int cS    = curCand->GetStrangeness();
-	   //if(piF&&gaF&&cPDG!=90000001&&cPDG!=90001000) // Both flags, in case of pi-first-int
-	   //if(piF&&gaF&&cBN!=1&&cBN!=3) // Both flags, which is in case of pi-first-int
-	   if(piF&&gaF&&cBN!=1)// @@ Should be both, which is in case of pi-first-interaction @@ ?
-	   //if(piF&&gaF&&cBN!=1&&cBN!=4) // Should be both, in case of pi-first-interaction
+    //if(piF&&gaF&&cPDG!=90000001&&cPDG!=90001000) // Both flags, in case of pi-first-int
+    //if(piF&&gaF&&cBN!=1&&cBN!=3) // Both flags, which is in case of pi-first-int
+    if(piF&&gaF&&cBN!=1)// @@ Should be both, which is in case of pi-first-interaction @@ ?
+    //if(piF&&gaF&&cBN!=1&&cBN!=4) // Should be both, in case of pi-first-interaction
     {
       curCand->SetPreProbability(0.);  
       curCand->SetDenseProbability(0.); 
-	     curCand->SetPossibility(false);    
+      curCand->SetPossibility(false);    
 #ifdef cldebug
       if(cPDG==90001001) G4cout<<"G4QNuc::PrepCand: piF/gaF fragments are blocked"<<G4endl;
@@ -2887,15 +2892,15 @@
     }
     // @@ in case of the Ksi or Omega- capture it can disturb the simulation
-	   else if(cPDG<80000000&&(abs(cPDG)%10>4||cST>2))// @@ PreClosed HighSpin/Strange hadrons
+    else if(cPDG<80000000&&(abs(cPDG)%10>4||cST>2))// @@ PreClosed HighSpin/Strange hadrons
     {
       curCand->SetPreProbability(0.);  
       curCand->SetDenseProbability(0.); 
-	     curCand->SetPossibility(false);    
+      curCand->SetPossibility(false);    
     }
     else
-	   {
+    {
       G4double tnM=GetQPDG().GetMass();          // Total mass of this nucleus
       if(cPDG>80000000&&cPDG!=90000000)          // ===> Cluster case
-	     {
+      {
         G4int sc = cST;                          // "S" of the cluster
         G4int zc = curCand->GetCharge();         // "Z" of the cluster
@@ -2906,5 +2911,5 @@
         pos      = probVect[ac];                 // Cluster Probability NormalizationFactor
         if(ac<=maxClust&&pos>0.&&(pLV==zeroLV||intLV.m()>.00001+cM))
-	       {
+        {
 
 #ifdef cldebug
@@ -2913,5 +2918,5 @@
           G4int dac=ac+ac;
           if(ac && (piF || gaF))                 // zc>=0
-										{
+          {
             if     (piF&&!gaF&&zc+ac) pos*=(zc+ac)/ac;  // piF interaction (#of u-quarks)
             else if(gaF&&!piF&&zc+dac) pos*=(zc+dac)/ac; // gaF interaction (sum of Q_q^2)
@@ -2921,10 +2926,10 @@
           else if(ac==2&&pos>0.)dense=probVect[255]/pos;
 #ifdef cldebug
-	         G4cout<<"G4QNucleus::PrepC: cPDG="<<cPDG<<",norm="<<pos<<",zc="<<zc<<",nc="<<nc
+          G4cout<<"G4QNucleus::PrepC: cPDG="<<cPDG<<",norm="<<pos<<",zc="<<zc<<",nc="<<nc
                 <<",sc="<<sc<<",ac="<<ac<<",ze1="<<ze1<<",ne1="<<ne1<<",se1="<<se1<<G4endl;
           G4double mp=pos;
 #endif
           if     (ac==1 && ae)                   // ae=0 protection (since here no /pos)
-	         {
+          {
             if     (zc) pos*=ze/ae;
             else if(nc) pos*=ne/ae;
@@ -2936,5 +2941,5 @@
 #ifdef cldebug
             if(pos)
-			         G4cout<<"G4QN::PrC:mp="<<mp<<",pos="<<pos<<",ae="<<ae
+            G4cout<<"G4QN::PrC:mp="<<mp<<",pos="<<pos<<",ae="<<ae
                   <<",Z="<<zc<<",N="<<nc<<",mac="<<mac<<G4endl;
             sZ+=pos*zc;
@@ -2943,8 +2948,8 @@
           }
           else if(ac==2)
-	         {
+          {
             if(ze<zc||ne<nc||se<sc) pos=0.;
             else if(aea)                         // Protection against aea=0.
-		          {
+            {
               if     (zc==2) pos*=ze*(ze-1)/aea;
               else if(nc==2) pos*=ne*(ne-1)/aea;
@@ -2960,10 +2965,10 @@
               //else if(sc==1&&nc==1) pos*=se*ne;
               else G4cout<<"***G4QNucl::PrepCand: z="<<zc<<", n="<<nc<<", s="<<sc<<G4endl;
-		            // Normalization for only not strange matter
-		          }
+              // Normalization for only not strange matter
+            }
             acm=2;
 #ifdef cldebug
             if(pos)
-		          G4cout<<"G4QN::PrC:mp="<<mp<<",p="<<pos<<",A=2,(Z="<<zc<<",N="<<nc<<"),m="
+            G4cout<<"G4QN::PrC:mp="<<mp<<",p="<<pos<<",A=2,(Z="<<zc<<",N="<<nc<<"),m="
                   <<mac<<G4endl;
             sZ+=pos*zc;
@@ -2972,7 +2977,7 @@
           }
           else                                     // ac>2
-	         {
+          {
             if(acm<ac)                             // first time that big cluster
-		          {
+            {
               if(ac<ae1 && ac>0) comb*=(ae1-ac)/ac;
               acm=ac;
@@ -2980,5 +2985,5 @@
               cca=0;
               if(ac%2) mac=7;                      // @@Change it if cluster set is changed
-		            else     mac=8;                      // @@ It is not yet automatic
+              else     mac=8;                      // @@ It is not yet automatic
 #ifdef cldebug
               G4cout<<"G4QNuc::PrepCl:c="<<comb<<",ac="<<ac<<"("<<index<<"),m="<<mac<<",a="
@@ -2989,14 +2994,14 @@
             if(ze1<=zc||ne1<=nc||se1<=sc) prod=0.;
             else
-		          {
+            {
               if(zc>0) for(int iz=1; iz<=zc; iz++) prod*=(ze1-iz)/iz;
               if(nc>0) for(int in=1; in<=nc; in++) prod*=(ne1-in)/in;
               if(sc>0) for(int is=1; is<=sc; is++) prod*=(se1-is)/is;
-		          }
+            }
             s+=prod;
             pos*=prod;
             pos/=comb;
 #ifdef cldebug
-		          if(pos) G4cout<<"G4QN::PreC:c="<<cPDG<<",p="<<pos<<",i="<<index<<",m="<<mac
+            if(pos) G4cout<<"G4QN::PreC:c="<<cPDG<<",p="<<pos<<",i="<<index<<",m="<<mac
                           <<",pr="<<prod<<",c="<<cca<<G4endl;
             sZ+=pos*zc;
@@ -3004,24 +3009,24 @@
 #endif
             cca++;
-	         }
+          }
           curCand->SetPreProbability(pos);
           curCand->SetDenseProbability(pos*dense);
 #ifdef cldebug
-	         G4cout<<"G4QN::PrepC: ClusterPDG="<<cPDG<<",preProb="<<pos<<",d="<<dense<<G4endl;
-#endif
-        }
-	       else                                       // => "Cluster is too big" case
+          G4cout<<"G4QN::PrepC: ClusterPDG="<<cPDG<<",preProb="<<pos<<",d="<<dense<<G4endl;
+#endif
+        }
+        else                                       // => "Cluster is too big" case
         {
           curCand->SetPreProbability(0.);     
           curCand->SetDenseProbability(0.);
-	         curCand->SetPossibility(false);          // This candidate is not possible 
-        }
-	     }
-	     else
+          curCand->SetPossibility(false);          // This candidate is not possible 
+        }
+      }
+      else
       {
         curCand->SetPreProbability(pos);           // ===> Hadronic case in Vacuum     
         curCand->SetDenseProbability(0.);          // ===> Hadronic case in Vacuum
       }
-	     curCand->SetPossibility(true);           // All candidates are possible at this point
+      curCand->SetPossibility(true);           // All candidates are possible at this point
     }
   } // End of the LOOP over Candidates
@@ -3059,5 +3064,5 @@
   // @@ --- Temporary "Lambda/Delta barrier for mesons"
   //if(!cA) cb+=40.;
-		// --- End of Temporary ^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+  // --- End of Temporary ^^^^^^^^^^^^^^^^^^^^^^^^^^^^
   return cb;
 } // End of "CoulombBarier"
@@ -3148,10 +3153,10 @@
   G4double GSM=GetGSMass();
 #ifdef debug
-		G4cout<<"G4QNucl::CBPenProb:GSM="<<GSM<<",Z="<<Z<<",N="<<N<<",C="<<C<<",B="<<B<<G4endl;
+  G4cout<<"G4QNucl::CBPenProb:GSM="<<GSM<<",Z="<<Z<<",N="<<N<<",C="<<C<<",B="<<B<<G4endl;
 #endif
   if(2>3);
   // @@ Temporary "Mass Barrier for mesons" @@ __________________
   //else if(!B) wD=40.;
-		// @@ End of Temporary^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+  // @@ End of Temporary^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
   ////else if(nA<7&&B>0)  wD=0.;    // Only Coulomb Barrier can reflect !!!
   ////else if((nA<12||nA>16)&&B>0) wD=0.;// Only CoulombB can reflect !!! O16 E-dep of gamA
@@ -3174,5 +3179,5 @@
     wD=80.; // 40 MeV per each nucleon
     //wD=wD/2;
-			 // @@ End of Temporary^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+    // @@ End of Temporary^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
   }
   ////else if(B>2)  wD=0.;
@@ -3190,18 +3195,18 @@
   if(wD<0.) wD=0.;
 #ifdef debug
-		G4cout<<"G4QNucl::CBPenProb: wD="<<wD<<",E="<<E<<",CB="<<CB<<G4endl;
+  G4cout<<"G4QNucl::CBPenProb: wD="<<wD<<",E="<<E<<",CB="<<CB<<G4endl;
 #endif
   // @@ Temporary "Virial factor" @@ __________________
   wD=wD+wD;
-		// @@ End of Temporary^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+  // @@ End of Temporary^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
   G4double sR=0.;
   G4double CBD=CB+wD;
   G4double ED=E+wD;
   if(CBD<0.) return 1.;
-  if(ED<0.)  return 0.;
-  //if(nA<27) sR=sqrt(wD/(E+wD));
-  //else      sR=sqrt((CB+wD)/(E+wD));
-  sR=sqrt((CB+wD)/(E+wD));
-  //sR=sqrt(wD/(E+wD));
+  if(ED<=0.)  return 0.;
+  //if(nA<27) sR=sqrt(wD/ED);
+  //else      sR=sqrt(CBD/ED);
+  sR=sqrt(CBD/ED);
+  //sR=sqrt(wD/ED);
 #ifdef pdebug
   G4cout<<"G4QN::CBPP:s="<<sR<<",E="<<E<<",w="<<wD<<",CB="<<CB<<",B="<<B<<",C="<<C<<G4endl;
@@ -3232,25 +3237,25 @@
 void G4QNucleus::ChooseNucleons()
 {
-	 G4int protons =0;
-	 G4int nucleons=0;
+  G4int protons =0;
+  G4int nucleons=0;
   G4int myA=GetA();
-	 while (nucleons < myA)
-	 {
-	   if(protons<Z && G4UniformRand() < G4double(Z-protons)/G4double(myA-nucleons) )
-	   {
-	     protons++;
+  while (nucleons < myA)
+  {
+    if(protons<Z && G4UniformRand() < G4double(Z-protons)/G4double(myA-nucleons) )
+    {
+      protons++;
       nucleons++;
       G4QHadron* proton = new G4QHadron(2212);
-	     theNucleons.push_back(proton);
-	   }
-	   else if ( (nucleons-protons) < (myA-Z) )
-	   {
+      theNucleons.push_back(proton);
+    }
+    else if ( (nucleons-protons) < (myA-Z) )
+    {
       nucleons++;
       G4QHadron* neutron = new G4QHadron(2112);
-	     theNucleons.push_back(neutron);
-	   }
-	   else G4cout<<"G4QNucleus::ChooseNucleons not efficient"<<G4endl;
-	 }
-	 return;
+      theNucleons.push_back(neutron);
+    }
+    else G4cout<<"G4QNucleus::ChooseNucleons not efficient"<<G4endl;
+  }
+  return;
 } // End of ChooseNucleons
 
@@ -3260,43 +3265,43 @@
   static const G4double mProt= G4QPDGCode(2212).GetMass();
   static const G4double mProt2= mProt*mProt;
-	 G4int i=0;                                  // general index
+  G4int i=0;                                  // general index
   G4int myA=GetA();                           // cashed value of A
-	 G4ThreeVector	aPos;                         // Prototype of nucleon position
-	 G4ThreeVector	delta;                        // Prototype of distance between nucleons
+  G4ThreeVector aPos;                         // Prototype of nucleon position
+  G4ThreeVector delta;                        // Prototype of distance between nucleons
   G4ThreeVector* places = new G4ThreeVector[myA]; // Vector of 3D positions
   G4double*      placeM = new G4double[myA];  // Vector of radii
-	 G4bool		freeplace;                          // flag of free space available
-	 G4double nucDist2 = nucleonDistance*nucleonDistance; // @@ can be a common static
-	 G4double maxR=GetRadius(0.01);              // there are no nucleons at this density
-	 while(i<myA)                                // LOOP over all nucleons
-	 {
-	   aPos = maxR*RandomUnitSphere();           // Get random position of nucleon iside maxR
-	   G4double density=GetRelativeDensity(aPos);
-	   if(G4UniformRand()<density)               // Try this position with frequency ~Density
-	   {
-	     freeplace = true;                       // Imply that there is a free space
-	     for(G4int j=0; j<i && freeplace; j++)   // Check that there is no overlap with others
-	     {
-	       delta = places[j] - aPos;             // Distance to nucleon j
+  G4bool  freeplace;                          // flag of free space available
+  G4double nucDist2 = nucleonDistance*nucleonDistance; // @@ can be a common static
+  G4double maxR=GetRadius(0.01);              // there are no nucleons at this density
+  while(i<myA)                                // LOOP over all nucleons
+  {
+    aPos = maxR*RandomUnitSphere();           // Get random position of nucleon iside maxR
+    G4double density=GetRelativeDensity(aPos);
+    if(G4UniformRand()<density)               // Try this position with frequency ~Density
+    {
+      freeplace = true;                       // Imply that there is a free space
+      for(G4int j=0; j<i && freeplace; j++)   // Check that there is no overlap with others
+      {
+        delta = places[j] - aPos;             // Distance to nucleon j
         freeplace= delta.mag2()>nucDist2;     // If false break the LOOP (M.K.)
         if(!freeplace) break;                 // M.K. acceleration
-	     }
-		    //  protons must at least have binding energy of CoulombBarrier (@@ ? M.K.), so
-		    //  assuming Fermi Energy corresponds to Potential, we must place protons such
-		    //  that the Fermi Energy > CoulombBarrier (?)
-	     if(freeplace && theNucleons[i]->GetPDGCode() == 2212) // Free Space Protons
-	     {
-  		    G4double pFermi=GetFermiMomentum(GetDensity(aPos));
-	       G4double eFermi= sqrt(pFermi*pFermi+mProt2)-mProt; // Kinetic energy
-	       if (eFermi <= CoulombBarrier()) freeplace=false;
-	     }
-	     if(freeplace)
-	     {
-		      places[i]=aPos;
-		      ++i;
-	     }
-	   }
-	 }
-	 ReduceSum(places,placeM);                    // Reduce center of mass shift (equalWeight)
+      }
+      //  protons must at least have binding energy of CoulombBarrier (@@ ? M.K.), so
+      //  assuming Fermi Energy corresponds to Potential, we must place protons such
+      //  that the Fermi Energy > CoulombBarrier (?)
+      if(freeplace && theNucleons[i]->GetPDGCode() == 2212) // Free Space Protons
+      {
+        G4double pFermi=GetFermiMomentum(GetDensity(aPos));
+        G4double eFermi= sqrt(pFermi*pFermi+mProt2)-mProt; // Kinetic energy
+        if (eFermi <= CoulombBarrier()) freeplace=false;
+      }
+      if(freeplace)
+      {
+        places[i]=aPos;
+        ++i;
+      }
+    }
+  }
+  ReduceSum(places,placeM);                    // Reduce center of mass shift (equalWeight)
   for(i=0; i<myA; i++) theNucleons[i]->SetPosition(places[i]);
   delete [] places;
@@ -3318,10 +3323,10 @@
   G4double At2= At*At;
   if(iA<17)                                         // Gaussian density distribution
-		{
+  {
     radius = r0sq*At2;                              // Mean Squared Radius (fm^2)
     rho0   = pow(pi*radius, -1.5);                  // Central Density
   }
   else                                              // Wood-Saxon density distribution
-		{
+  {
     G4double r0=1.16*(1.-1.16/At2)*fermi;           // Base for A-dependent radius
     G4double rd=deld/r0;                            // Relative thickness of the surface
@@ -3384,31 +3389,31 @@
   G4ThreeVector* momentum = new G4ThreeVector[myA];
   G4double*      fermiM   = new G4double[myA];
-	 for(i=0; i<myA; i++) // momenta for all, including the last, in case we swap nucleons
-	 {
-	   density=GetDensity(theNucleons[i]->GetPosition());// density around nucleon i
-	   G4double ferm = GetFermiMomentum(density);        // module of momentun for nucleon i
-	   fermiM[i] = ferm;                                 // module of momentun for nucleon i
-	   G4ThreeVector mom=ferm*RandomUnitSphere();        // 3-vector for nucleon mpomentum
-	   if(theNucleons[i]->GetPDGCode() == 2212)           // the nucleon is proton
-	   {
-	     G4double eMax = sqrt(ferm*ferm+mProt2)-CoulombBarrier();
-	     if(eMax>mProt)
-	     {
-	       G4double pmax2= eMax*eMax - mProt2;
-		      fermiM[i] = sqrt(pmax2);                      // modify proton momentum
-		      while(mom.mag2() > pmax2) mom=Get3DFermiMomentum(density, fermiM[i]);
-	     }
+  for(i=0; i<myA; i++) // momenta for all, including the last, in case we swap nucleons
+  {
+    density=GetDensity(theNucleons[i]->GetPosition());// density around nucleon i
+    G4double ferm = GetFermiMomentum(density);        // module of momentun for nucleon i
+    fermiM[i] = ferm;                                 // module of momentun for nucleon i
+    G4ThreeVector mom=ferm*RandomUnitSphere();        // 3-vector for nucleon mpomentum
+    if(theNucleons[i]->GetPDGCode() == 2212)           // the nucleon is proton
+    {
+      G4double eMax = sqrt(ferm*ferm+mProt2)-CoulombBarrier();
+      if(eMax>mProt)
+      {
+        G4double pmax2= eMax*eMax - mProt2;
+        fermiM[i] = sqrt(pmax2);                      // modify proton momentum
+        while(mom.mag2() > pmax2) mom=Get3DFermiMomentum(density, fermiM[i]);
+      }
       else
-	     {
-	       G4cerr<<"G4QNucleus: difficulty finding proton momentum -> mom=0"<<G4endl;
-		      mom=0;
-	     }
-	   }
-	   momentum[i]= mom;
-	 }
-	 ReduceSum(momentum,fermiM);                    // Reduse momentum nonconservation
+      {
+        G4cerr<<"G4QNucleus: difficulty finding proton momentum -> mom=0"<<G4endl;
+        mom=0;
+      }
+    }
+    momentum[i]= mom;
+  }
+  ReduceSum(momentum,fermiM);                    // Reduse momentum nonconservation
   for(i=0; i< myA ; i++ )
   {
-				G4double mN=mNeut;
+    G4double mN=mNeut;
     if(theNucleons[i]->GetPDGCode() == 2212) mN=mProt;
     G4double energy = mN - BindingEnergy()/myA;
@@ -3430,9 +3435,9 @@
   }
   G4int i=0;                                          // To avoid declaration in j-LOOP
-	 G4ThreeVector sum(0.,0.,0.);                        // The sum which must be reduced
+  G4ThreeVector sum(0.,0.,0.);                        // The sum which must be reduced
   G4double minV=DBL_MAX;                              // Min value of Fermi Momentum
   G4double maxV=0.;                                   // Max value of Fermi Momentum
   G4int    maxI=-1;                                   // Index of maximum Fermi Momentum
-	 for(i=0; i<myA; i++)
+  for(i=0; i<myA; i++)
   {
     sum+=momentum[i];                                 // Make sum of 3D Momenta
@@ -3453,5 +3458,5 @@
   }
   G4double* fm2   = new G4double[myA];                // collect temporary squared FermiMom
-	 for(i=0; i<myA; i++) fm2[i]=pFermiM[i]*pFermiM[i];  // calculate squared Fermi Momenta
+  for(i=0; i<myA; i++) fm2[i]=pFermiM[i]*pFermiM[i];  // calculate squared Fermi Momenta
   G4int myA1=myA-1;                                   // to avoid calculation in the j-LOOP
   for(G4int j=0; j<myA; j++)                          // Not more than myA attempts
@@ -3459,9 +3464,9 @@
     G4double minP=DBL_MAX;                            // Minimal progection value
     G4int    minI=-1;                                 // Minimal projection index
-	   for(i=0; i<myA; i++)                              // Sirch for minimum projection
+    for(i=0; i<myA; i++)                              // Sirch for minimum projection
     {
       G4double proj=fabs(sum.dot(momentum[i])/fm2[i]);// abs value of |sum|*cos(theta)
       if(proj<minP)
-				  {
+      {
         minP=proj;
         minI=i;
@@ -3484,5 +3489,5 @@
     }
   }
- 	return true;
+  return true;
 } // End of ReduceSum
 
@@ -3498,5 +3503,5 @@
   G4cout<<"G4QNucleus::Init3D: A="<<myA<<", Z="<<Z<<G4endl;
 #endif
-		InitDensity();
+  InitDensity();
   ChooseNucleons();  
   ChoosePositions();
@@ -3504,5 +3509,5 @@
   G4double Ebind= BindingEnergy()/myA;
   for (G4int i=0; i<myA; i++) theNucleons[i]->SetBindingEnergy(Ebind); // @@ ? M.K.
- 	currentNucleon=0;                                   // Automatically starts the LOOP
+  currentNucleon=0;                                   // Automatically starts the LOOP
   return;  
 } // End of Init3D
@@ -3511,12 +3516,12 @@
 G4double G4QNucleus::GetOuterRadius()
 {
-	 G4double maxradius2=0;
+  G4double maxradius2=0;
   G4int myA=theNucleons.size();
-	 if(myA) for(G4int i=0; i<myA; i++)
-	 {
-		 	G4double nucr2=theNucleons[i]->GetPosition().mag2();
-	   if(nucr2 > maxradius2) maxradius2=nucr2;
-	 }
-	 return sqrt(maxradius2)+nucleonDistance;
+  if(myA) for(G4int i=0; i<myA; i++)
+  {
+    G4double nucr2=theNucleons[i]->GetPosition().mag2();
+    if(nucr2 > maxradius2) maxradius2=nucr2;
+  }
+  return sqrt(maxradius2)+nucleonDistance;
 } // End of GetOuterRadius
 
@@ -3525,5 +3530,5 @@
 {
   G4int myA=theNucleons.size();
- 	if(myA) for(G4int i=0; i<myA; i++) theNucleons[i]->Boost(theBoost);
+  if(myA) for(G4int i=0; i<myA; i++) theNucleons[i]->Boost(theBoost);
 } // End of DoLorentzBoost(G4LorentzVector)
 
@@ -3532,5 +3537,5 @@
 {
   G4int myA=theNucleons.size();
- 	if(myA) for(G4int i=0; i<myA; i++) theNucleons[i]->Boost(theBoost);
+  if(myA) for(G4int i=0; i<myA; i++) theNucleons[i]->Boost(theBoost);
 } // End of DoLorentzBoost(G4ThreeVector)
 
@@ -3539,12 +3544,12 @@
 {
   G4double bet2=theBeta.mag2();
-	 G4double factor=(1.-sqrt(1.-bet2))/bet2;         // 1./(beta2*gamma2)
+  G4double factor=(1.-sqrt(1.-bet2))/bet2;         // 1./(beta2*gamma2)
   G4int myA=theNucleons.size();
- 	if(myA) for (G4int i=0; i< myA; i++)
-	 {
-	   G4ThreeVector pos=theNucleons[i]->GetPosition(); 
-	   pos -= factor*(theBeta*pos)*theBeta;  
-	   theNucleons[i]->SetPosition(pos);
-	 }    
+  if(myA) for (G4int i=0; i< myA; i++)
+  {
+    G4ThreeVector pos=theNucleons[i]->GetPosition(); 
+    pos -= factor*(theBeta*pos)*theBeta;  
+    theNucleons[i]->SetPosition(pos);
+  }    
 } // End of DoLorentzContraction(G4ThreeVector)
 
@@ -3553,5 +3558,5 @@
 {
   G4int myA=theNucleons.size();
- 	if(myA)	for(G4int i=0; i<myA; i++)
+  if(myA) for(G4int i=0; i<myA; i++)
     theNucleons[i]->SetPosition(theNucleons[i]->GetPosition() + theShift);
 } // End of DoTranslation
@@ -3562,6 +3567,6 @@
   G4int myA=theNucleons.size();
   if(myA) currentNucleon=0;
-		else G4cout<<"-Warning-G4QNucleus::StartLoop: LOOP starts for uninited nucleons"<<G4endl;
-	 return myA;
+  else G4cout<<"-Warning-G4QNucleus::StartLoop: LOOP starts for uninited nucleons"<<G4endl;
+  return myA;
 } // End of StartLoop
 
@@ -3580,5 +3585,5 @@
   G4double mT= C*B/(1+B);                   // Max (b=0) b-thickness
   G4double T = mT;                          // Current b-thickness
-		mT/=1000.;                                // Min b-thickness (@@ make 1000 a parameter)
+  mT/=1000.;                                // Min b-thickness (@@ make 1000 a parameter)
   G4double b = 0.;
   while(T>mT)
@@ -3803,9 +3808,9 @@
     G4double gsM=mNeut;
     if(thePDG==90001000)      gsM=mProt;
-	   else if(thePDG==91000000) gsM=mLamb;
+    else if(thePDG==91000000) gsM=mLamb;
     if(fabs(totMass-gsM)<.001)
     {
 #ifdef pdebug
-	     G4cout<<"G4QNu::EvaporateNucl:GSM="<<gsM<<", H="<<thePDG<<qH->Get4Momentum()<<G4endl;
+      G4cout<<"G4QNu::EvaporateNucl:GSM="<<gsM<<", H="<<thePDG<<qH->Get4Momentum()<<G4endl;
 #endif
       evaHV->push_back(qH); // (delete equivalent)
@@ -3816,5 +3821,5 @@
     }
     else if(totMass<gsM)
-	   {
+    {
 #ifdef qdebug
       if(!qH) G4cout<<"G4QNucleus::EvaporateNucleus: (2) qH="<<G4endl;
@@ -3832,12 +3837,12 @@
       G4double d=totMass-gsM;
 #ifdef pdebug
-	     G4cout<<"G4QN::EvaporNucl: PDG="<<thePDG<<",M="<<totMass<<">"<<gsM<<",d="<<d<<G4endl;
+      G4cout<<"G4QN::EvaporNucl: PDG="<<thePDG<<",M="<<totMass<<">"<<gsM<<",d="<<d<<G4endl;
 #endif
       G4int decPDG=22;
       G4double decM=0.;
       if(d>142.)                           // @@ to avoid more precise calculations
-						{
+      {
         if(thePDG==90001000)               // D+ -> n + pi+
-								{
+        {
           gsM=mNeut;
           thePDG=90000001;
@@ -3846,5 +3851,5 @@
         }
         else if(thePDG==90000001)          // D+ -> n + pi+
-								{
+        {
           gsM=mProt;
           thePDG=90001000;
@@ -3853,5 +3858,5 @@
         }
         else
-								{
+        {
           decPDG=111;
           decM=mPi0;
@@ -3874,5 +3879,5 @@
       }
 #ifdef pdebug
-	     G4cout<<"G4QNucl::EvaNuc:"<<totMass<<q4M<<"->"<<thePDG<<h4Mom<<"+g="<<g4Mom<<",n="
+      G4cout<<"G4QNucl::EvaNuc:"<<totMass<<q4M<<"->"<<thePDG<<h4Mom<<"+g="<<g4Mom<<",n="
             <<evaHV->size()<<G4endl;
 #endif
@@ -3912,5 +3917,5 @@
     {
 #ifdef pdebug
-	     G4cout<<"G4QN::EvaporateNuc:(D)GSM="<<gsM<<",H="<<thePDG<<qH->Get4Momentum()<<G4endl;
+      G4cout<<"G4QN::EvaporateNuc:(D)GSM="<<gsM<<",H="<<thePDG<<qH->Get4Momentum()<<G4endl;
 #endif
       G4LorentzVector h4Mom=q4M*(gsM/totMass);           // At rest in CM
@@ -3931,5 +3936,5 @@
     }
     else if(totMass<gsM+mPi)
-	   {
+    {
 #ifdef qdebug
       if(!qH) G4cout<<"G4QNucleus::EvaporateNucleus: (6) qH="<<G4endl;
@@ -3961,5 +3966,5 @@
       }
 #ifdef pdebug
-	     G4cout<<"G4QNuc::EvaNuc:"<<totMass<<q4M<<"->"<<thePDG<<h4Mom<<"+pi="<<g4Mom<<", nH="
+      G4cout<<"G4QNuc::EvaNuc:"<<totMass<<q4M<<"->"<<thePDG<<h4Mom<<"+pi="<<g4Mom<<", nH="
             <<evaHV->size()<<G4endl;
 #endif
@@ -4012,11 +4017,11 @@
     G4int   piPDG = -211;
     if(thePDG==90002999)
-	   {
+    {
       nucPDG = 2212;
       nucM   = mProt;
       piPDG  = 211;
-	   }
+    }
     if(totMass>mPi+nucM+nucM)
-	   {
+    {
       G4LorentzVector n14M(0.,0.,0.,nucM);
       G4LorentzVector n24M(0.,0.,0.,nucM);
@@ -4034,5 +4039,5 @@
         G4cerr<<"***G4QNucleus::EvaporateNucleus: tM="<<totMass<<"-> 2N="<<nucPDG<<"(M="
               <<nucM<<") + pi="<<piPDG<<"(M="<<mPi<<")"<<G4endl;
-		      throw G4QException("G4QNucleus::EvaporateNucleus: ISO-Dibaryon DecayIn3 error");
+        throw G4QException("G4QNucleus::EvaporateNucleus: ISO-Dibaryon DecayIn3 error");
       }
 #ifdef qdebug
@@ -4059,7 +4064,7 @@
 #endif
       evaHV->push_back(piH);                // (delete equivalent)
-	   }
-	   else
-	   {
+    }
+    else
+    {
 #ifdef qdebug
       if(!qH) G4cout<<"G4QNucleus::EvaporateNucleus: (11) qH="<<G4endl;
@@ -4073,5 +4078,5 @@
             <<" < M_2N+Pi, d="<<totMass-2*nucM-mPi<<G4endl;
       throw G4QException("G4QNucleus::EvaporateNucleus:ISO-DiBaryon is under MassShell");
-	   }
+    }
   }
   else if((thePDG==90000002||thePDG==90001001||thePDG==90002000)&&totMass>2020.) //=> IsoDB
@@ -4088,5 +4093,5 @@
     {
       if(G4UniformRand()>.5)
-						{
+      {
         n1PDG=2112;
         n1M=mNeut;
@@ -4094,5 +4099,5 @@
       }
       else
-						{
+      {
         n2PDG=2212;
         n2M=mProt;
@@ -4101,14 +4106,14 @@
     }
     if(totMass>mPi+n1M+n2M)
-	   {
+    {
       G4LorentzVector n14M(0.,0.,0.,n1M);
       G4LorentzVector n24M(0.,0.,0.,n2M);
       G4LorentzVector pi4M(0.,0.,0.,mPi);
       if(!G4QHadron(q4M).DecayIn3(n14M,n24M,pi4M))
-	     {
+      {
         G4cerr<<"***G4QNucl::EvapNucleus:IsoDN, tM="<<totMass<<"-> N1="<<n1PDG<<"(M="<<n1M
               <<") + N2="<<n2PDG<<"(M="<<n2M<<") + pi="<<piPDG<<" (Mpi="<<mPi<<")"<<G4endl;
-		      throw G4QException("G4QNucl::EvaporateNucleus:ISO-dibaryon excit. DecayIn3 error");
-	     }
+        throw G4QException("G4QNucl::EvaporateNucleus:ISO-dibaryon excit. DecayIn3 error");
+      }
 #ifdef qdebug
       if(!qH) G4cout<<"G4QNucleus::EvaporateNucleus: (12) qH="<<G4endl;
